/*******************************************************************************
* ļ          	: main.c
*              	: Losingamong
*   		: 17/09/2010
* 		        : 
********************************************************************************/


#define  SPI1_CS1_ENABLE() {GPIO_ResetBits(GPIOA, GPIO_Pin_4);}
#define  SPI1_CS1_DISABLE() {GPIO_SetBits(GPIOA,GPIO_Pin_4);}
/* ͷļ --------------------------------------------------------------------*/

#include "stm32f10x_lib.h"
#include "stdio.h"

/* Զͬؼ    --------------------------------------------------------*/

typedef enum {FAILED = 0, PASSED = !FAILED} TestStatus;

/* Զ        --------------------------------------------------------*/

#define BufferSize 32

/* Զ庯        --------------------------------------------------------*/

/* Զȫֱ      --------------------------------------------------------*/


#define  RESETCMD              0x4000

#define  ManualMode            0x1080//  manual mode    channel -1
#define  AutoMode_1		   0x2C00
//#define  AutoMode_2            0x3800                     ////////
#define  AutoMode_2            0x3C00                     ////////

#define ProgramReg_Auto1FRAME1   0x8000
#define ProgramReg_Auto1FRAME2   0x0FFF

#define ProgramReg_Auto2   0x92C0   //CH00---CH11

#define ContinuedSelecMode  0x00  //ignores data on DI11--DI00

void delay(void)
{
    unsigned char i;
    for(i=0;i<200;i++)
    {
      ;
    }

}

unsigned int SPI_RESULT;
unsigned int SPI_Readbyte(unsigned int data) 
 {     

		while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_TXE) == RESET);
		SPI_I2S_SendData(SPI1, data);      
	
    	while (SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET); 
     SPI_RESULT	 = SPI_I2S_ReceiveData(SPI1);
	asm("nop");
		return SPI_RESULT;
}
void RCC_Configuration(void);
void GPIO_Configuration(void);
void SPI_Configuration(void);
#define CS_HIGH()         GPIO_SetBits(GPIOA, GPIO_Pin_4)
#define CS_LOW()          GPIO_ResetBits(GPIOA, GPIO_Pin_4)

unsigned int SPI1_ReadWriteByte(unsigned int value)
{
	while(SPI_I2S_GetFlagStatus(SPI1,SPI_I2S_FLAG_TXE) == RESET);
	SPI_I2S_SendData(SPI1,value);

	while(SPI_I2S_GetFlagStatus(SPI1,SPI_I2S_FLAG_RXNE) ==RESET);

	return SPI_I2S_ReceiveData(SPI1);	
}
void SpiEnable(void)
{

		SPI1_CS1_ENABLE();

}

void SpiDisable(void)
{

		SPI1_CS1_DISABLE();


}
unsigned int ReadAD7952(unsigned int num)
{ 
    unsigned int value;

    SpiEnable();
    for(int k=0;k<8000;k++)
    {
        asm("nop");
    }
    value = SPI_Readbyte(num);

    SpiDisable();
    return value;
 }
/*******************************************************************************
* 		 : main
*        : main 
*        : 
*        : 
* ֵ         : 
*******************************************************************************/
unsigned int  ret[30],adresult,AD_SampResult;
unsigned char j;
int main(void)
{
    RCC_Configuration();
    GPIO_Configuration();
    SPI_I2S_DeInit(SPI1);

    SPI_Configuration();
    
    ret[0] = ReadAD7952(0x4000);  //ѡͨ,ַ	

    ret[1] = ReadAD7952(0x92c0);  //ѡͨ,ַ	

    ret[2] = ReadAD7952(0x3c00);

    ret[2] = ReadAD7952(0);

    ret[4] = ReadAD7952(0xffff);

    for(j=0;j<12;j++)
    {
        ret[5+j] = ReadAD7952(0xffff);
        asm("nop"); 
    }

    while(1)
    {
        for(j=0;j<12;j++)
        {
            ret[5+j] = ReadAD7952(0xffff);
            asm("nop"); 
        }
        asm("nop"); 
    }
    
  
}

/*******************************************************************************
* 		: RCC_Configuration
*   	: ϵͳʱ
*   	: 
*   	: 
* ֵ    	: 
*******************************************************************************/

void RCC_Configuration(void)
{
	/* öͱ HSEStartUpStatus */
	ErrorStatus HSEStartUpStatus;
	
  	/* λϵͳʱ */
  	RCC_DeInit();
	
  	/*  HSE */
  	RCC_HSEConfig(RCC_HSE_ON);
	
  	/* ȴ HSE ȶ */
  	HSEStartUpStatus = RCC_WaitForHSEStartUp();
	
	/* ж HSE Ƿɹif()ڲ */
  	if(HSEStartUpStatus == SUCCESS)
  	{
    	/* ѡ HCLKAHBʱԴΪSYSCLK 1Ƶ */
    	RCC_HCLKConfig(RCC_SYSCLK_Div1); 
		
    	/* ѡ PCLK2 ʱԴΪ HCLKAHB 1Ƶ */
    	RCC_PCLK2Config(RCC_HCLK_Div1); 
		
    	/* ѡ PCLK1 ʱԴΪ HCLKAHB 2Ƶ */
    	RCC_PCLK1Config(RCC_HCLK_Div2);
		
    	/*  FLASH ʱΪ2 */
    	FLASH_SetLatency(FLASH_Latency_2);
		
    	/* ʹ FLASH Ԥȡ */
    	FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
		
    	/* ѡ໷PLLʱԴΪHSE 1ƵƵΪ9PLLƵΪ 8MHz * 9 = 72MHz */
    	RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);
		
    	/* ʹ PLL */ 
    	RCC_PLLCmd(ENABLE);
		
    	/* ȴ PLL ȶ */
    	while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);
		
    	/* ѡ SYSCLK ʱԴΪ PLL */
    	RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);
		
    	/* ȴ PLL Ϊ SYSCLK ʱԴ */
    	while(RCC_GetSYSCLKSource() != 0x08);
  	}
	
	/*  SPI2 ʱ */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);
	/*  GPIOAGPIOBUSART1  SPI1 ʱ */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB | 
						   RCC_APB2Periph_USART1 |RCC_APB2Periph_SPI1, ENABLE);
        
        
        	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA |RCC_APB2Periph_AFIO|RCC_APB2Periph_SPI1, ENABLE );
	//RCC_AHBPeriphClockCmd(RCC_AHBPeriph_FSMC, ENABLE); 
}



/*******************************************************************************
*   		: GPIO_Configuration
*     	: øGPIO˿ڹ
*       : 
*       : 
* ֵ        : 
*******************************************************************************/

void GPIO_Configuration(void)
{  	
	/*  GPIO ʼṹ GPIO_InitStructure */
	GPIO_InitTypeDef GPIO_InitStructure;
	
	/*  SPI1 : SCK, MISO  MOSI */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
        
        GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
        
        
        
        

	GPIO_StructInit(&GPIO_InitStructure);  //ʼṹ
	// /cs1
        GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_4;
        GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
        GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
        GPIO_Init(GPIOA, &GPIO_InitStructure);
	SPI1_CS1_ENABLE();
	//   SCK,MOSI
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	//   MISO
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;
	////GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	
	GPIO_Init(GPIOA, &GPIO_InitStructure);
}



/*******************************************************************************
*   		: SPI_Configuration
*     	:  SPI 
*       : 
*       : 
* ֵ        : 
*******************************************************************************/

void SPI_Configuration(void)
{
	/* 
	*	SPI Ϊ˫˫ȫ˫ 
	*  	SPI ͽ 8 λ֡ṹ 
	*  	ʱյ 
	*  	ݲڵڶʱ 
	*	ڲ NSS ź SSI λ
	*	ԤƵֵΪ 4
	*	ݴ LSB λʼ
	*	 CRC ֵĶʽ 
	*/
	SPI_InitTypeDef SPI_InitStructure;

	
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_16b;
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256;
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
	SPI_InitStructure.SPI_CRCPolynomial = 7;
	SPI_Init(SPI1,&SPI_InitStructure);
	SPI_Cmd(SPI1,ENABLE);

}

